/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.node.impl;

import javax.annotation.Nonnull;
import java.util.Set;
import java.util.TreeSet;
import it.tidalwave.semantic.other.Repository;
import it.tidalwave.semantic.other.Type;
import org.openide.nodes.Children;

/**
 *
 * @author fritz
 */
public class NamespaceNode extends SemanticNode
  {
    @Nonnull
    private final String nameSpace;

    protected static class NamespaceChildFactory extends TypeNode.TypeChildFactory
      {
        @Nonnull
        private final Repository repository;

        @Nonnull
        private final String nameSpace;

        public NamespaceChildFactory (@Nonnull final Repository repository,
                                      @Nonnull final String nameSpace)
          {
            super(null);
            this.repository = repository;
            this.nameSpace = nameSpace;
          }

        @Override
        @Nonnull
        protected Set<Type> findTypes()
          {
            final Set<Type> result = new TreeSet<Type>();

            for (final Type type : repository.getAllTypes())
              {
                if (type.getId().stringValue().startsWith(nameSpace))
                  {
                    result.add(type);
                  }
              }

            return result;
          }
      }

    public NamespaceNode (@Nonnull final Repository repository,
                          @Nonnull final String nameSpace)
      {
        super(Children.create(new NamespaceChildFactory(repository, nameSpace), true));
        this.nameSpace = nameSpace;
        setName(nameSpace);
        setDisplayName(nameSpace);
      }
//
//    @Nonnull
//    @Override
//    public String getDisplayName()
//      {
//        return nameSpace;
//      }
  }
